#include <stdio.h>
#include "test_macros.hpp"

#include <matrix/math.hpp>

using namespace matrix;

template class SquareMatrix<float, 3>;

int main()
{
    Euler<float> euler(0.1f, 0.2f, 0.3f);
    Dcm<float> R(euler);
    Dcm<float> skew = R - R.T();
    Vector3<float> w = skew.vee();
    Vector3<float> w_check(0.1348f, 0.4170f, 0.5647f);

    TEST(isEqual(w, w_check));
    TEST(isEqual(skew, w.hat()));
    return 0;
}

/* vim: set et fenc=utf-8 ff=unix sts=0 sw=4 ts=4 : */
